<?php
/*******************************************************************************
 *
 * Copyright (c) 2004-2017 Calame Software
 *
 *******************************************************************************/
 
define ('ERR_HTTP_CONNECT', 2000001);
define ('ERR_HTTP_WRITE',   2000002);
define ('ERR_HTTP_READ',    2000003);
define ('ERR_HTTP_NOCONFIG_FILE', 2000004);
define ('ERR_HTTP_INVALIDCONFIG_FILE', 2000005);

define ('GT_ERR', "ERR");
define ('GT_OK', "OK");
 
//------------------------------------------------------------------------------
// 
//------------------------------------------------------------------------------

function write_reponse($data)
{
	$size = strlen($data);

	header("Charset=utf8");
	header("Content-Type: application/octet-stream");
	header("Content-Transfer-Encoding: binary"); 
	header("Content-Length: $size");
	header("Expires: 0"); 
	if(strstr($_SERVER["HTTP_USER_AGENT"],"MSIE") === false) {
		header("Cache-Control: no-cache, must-revalidate");
		header("Pragma: no-cache");
	} else {
		header("Cache-Control: private");
		header('Pragma: private');
	}
	echo $data;	
}

//------------------------------------------------------------------------------
// 
//------------------------------------------------------------------------------	

function do_gterror($msg, $code, $gtmode) 
{
	if ($gtmode === true)
		write_reponse(GT_ERR."\t".$code."\t".$msg);
}

//------------------------------------------------------------------------------
// 
//------------------------------------------------------------------------------	

function write_gterror($error) 
{
	header("Content-type: text/plain");
	if (count($error) >= 2)
	{
		echo "GTServer error\n";
		echo "Status: ".$error[0]."\nCode  : ".$error[1];
		if (count($error) > 2)
			echo "\nMessage: ".$error[2];
	}
	else
		print_r($error);
}

function write_gterror_2($errcode, $errmsg)
{
	$res[0] = GT_ERR;
	$res[1] = $errcode;
	$res[2] = $errmsg;
	write_gterror($res);
}	

//------------------------------------------------------------------------------
// 
//------------------------------------------------------------------------------

function get_instance_params($alias, &$srv, &$port, &$sslmode, &$timeout, &$errcode, &$errmsg)
{
	$filesrvconf = ROOT_PATH."/config/".$alias.".conf";	
	
	if (file_exists($filesrvconf) && is_readable($filesrvconf)) 
	{
		$params = parse_ini_file($filesrvconf);
		if (isset($params['IPADD']) && isset($params['PORT'])) 
		{
			$srv = $params['IPADD'];
			$port = $params['PORT'];
			$sslmode = "";
			$timeout = 120;
			if (isset($params['SSLMODE']))
			{
				$sslmode = $params['SSLMODE'];
			}
			if (isset($params['TIMEOUT']))
			{
				$timeout = $params['TIMEOUT'];				
			}
			return true;
		}
		else
		{
			$errcode = ERR_HTTP_INVALIDCONFIG_FILE;
			$errmsg = "Invalid config file, missige IPADD or PORT";
		}
	}
	else
	{
		$errcode = ERR_HTTP_NOCONFIG_FILE;
		$errmsg = "No config file or file not readable for instance $alias"; 
	}
	return false;
}

//------------------------------------------------------------------------------
// 
//------------------------------------------------------------------------------

function proxy($send, $srv, $port, $sslmode, $timeout, $gtmode)
{
	$context = stream_context_create();
	
	if ($sslmode != "") 
	{
		$ip = $sslmode.'://'.$srv;		
		stream_context_set_option($context, 'ssl', 'verify_peer', false);
		stream_context_set_option($context, 'ssl', 'verify_peer_name', false);
	} else {
		$ip = $srv;
	}	
		
	$fp = @stream_socket_client($ip.":".$port, $errno, $errstr, 1, STREAM_CLIENT_CONNECT, $context);
	
	if ($fp === false) 
	{
		do_gterror("Connect", ERR_HTTP_CONNECT, $gtmode);
		return "";	
	}

	// envoi
	$nLength = strlen($send);
	$BinCmd = pack("L", $nLength);
	
	$written = fwrite($fp, $BinCmd, 4);
	if ($written !== 4)
	{
		do_gterror("Write(size)", ERR_HTTP_WRITE, $gtmode);
		return "";
	}
	
	$written = fwrite($fp, $send, $nLength);
	if ($written !== $nLength)
	{
		do_gterror("Write(data)", ERR_HTTP_WRITE, $gtmode);
		return "";
	}

	//réception
	stream_set_timeout($fp, $timeout);
	
	if (feof($fp)) 
	{
		do_gterror("Read(First)", ERR_HTTP_READ, $gtmode);
		return "";
	}	
	
//	$length = fread($fp, 4);
	
	// lecture byte/byte sinon fail en SSL
	$length = fread($fp, 1);
	if (feof($fp)) 
	{
		do_gterror("Read", ERR_HTTP_READ, $gtmode);
		return "";
	}	
	$length .= fread($fp, 1);
	if (feof($fp)) 
	{
		do_gterror("Read", ERR_HTTP_READ, $gtmode);
		return "";
	}	
	$length .= fread($fp, 1);
	if (feof($fp)) 
	{
		do_gterror("Read", ERR_HTTP_READ, $gtmode);
		return "";
	}	
	$length .= fread($fp, 1);
	
	
	if (strlen($length) == 4) 
	{        
		$array = unpack("L", $length);
	}
	else
	{			
		do_gterror("Read(size)", ERR_HTTP_READ, $gtmode);
	}	
		
	$data = '';
	if (isset($array)) 
	{
		while (!feof($fp)) 
		{
			$data .= fread($fp, 8192);    
			if (strlen($data) >= $array[1]) 
				break;
		}
	}
	fclose ($fp);
		
	
	return $data;
}

//------------------------------------------------------------------------------
// $maxcount = nombre max après OK
//------------------------------------------------------------------------------

function parse_server_answer($recieved, $maxcount)
{	
	if ($recieved === "")
		exit(0);
	
	if ($maxcount <= 0)
		exit(0);
	
	$pos = strpos($recieved, "\t");
	if ($pos === false)
	{
		$res[0] = $recieved;
		return $res;
	}
	
	$res[0] = substr($recieved, 0, $pos);
	$recieved = substr($recieved, $pos + 1);
	$pos = strpos($recieved, "\t");
	
	if ($res[0] == GT_ERR)
	{		
		if ($pos === false)
		{
			$res[1] = $recieved;
		}
		else
		{
			$res[1] = substr($recieved, 0, $pos);
			$res[2] = substr($recieved, $pos + 1);			
		}
		return $res;
	}	
	
	// pas d'erreur
	$current = 1;
	while (($pos !== false) && ($current < $maxcount))
	{
		$res[$current] = substr($recieved, 0, $pos);
		$recieved = substr($recieved, $pos + 1);
		$pos = strpos($recieved, "\t");
		$current = $current + 1;
	}
	$res[$current] = $recieved;
	
	return $res;
}

//------------------------------------------------------------------------------
// 
//------------------------------------------------------------------------------

function do_test($alias, $srv, $port, $sslmode, $timeout)
{
	header("Cache-Control: no-cache, must-revalidate");
	header("Pragma: no-cache");
	header("Content-type: text/plain");
	echo "GTWeb: OK.\n";
	
	$send = "2";	// 2 = status
	
	$recieved = proxy($send, $srv, $port, $sslmode, $timeout, false);	
	
	if ($recieved === "")
	{
		echo "Communication with GTServer failed."; 
		exit(0);
	}
	
	$res = parse_server_answer($recieved, 3);

	if (count($res) <= 0)
	{
		echo "Invalid GTServer response: \n"; 
		print_r($res);
		exit(0);	
	}
	
	if ($res[0] == GT_ERR)
	{
		write_gterror($res);
		exit(0);
	}	
	
	if ($res[0] == GT_OK)
	{
		echo "GTServer: OK.";
		exit (0);
	}
	
	echo "Invalid GTServer response: \n"; 
	print_r($res);
	exit(0);	
}	

//------------------------------------------------------------------------------
//  Ouvrir un qst
//------------------------------------------------------------------------------

function open_qst($alias, $srv, $port, $sslmode, $timeout, $qstid, $name)
{		
	$send = "4\t".$qstid;	// 4 = qstsync

	$recieved = proxy($send, $srv, $port, $sslmode, $timeout, false);	
	
	if ($recieved === "")
		exit(0);
	
	$res = parse_server_answer($recieved, 3);
	
	if (count($res) <= 0)
		exit(0);
	
	if ($res[0] == GT_ERR)
	{
		write_gterror($res);
		return;
	}
	
	if ($res[0] != GT_OK)
		exit(0);
	
	if (count($res) == 3)
	{			
		$data = base64_decode($res[2]);
		$size = strlen($data);
		header("Charset=utf8");
		header("Content-Type: application/octet-stream; name=\"" . $name . "\""); 
		header("Content-Transfer-Encoding: binary"); 
		header("Content-Length: $size"); 
		header("Content-Disposition: attachment; filename=\"" . $name . "\""); 
		header("Expires: 0"); 
		if(strstr($_SERVER["HTTP_USER_AGENT"],"MSIE") === false) {
			header("Cache-Control: no-cache, must-revalidate");
			header("Pragma: no-cache");
		} else {
			header("Cache-Control: private");
			header('Pragma: private');
		}
		echo $data;
	}
}	
	
?>